#include <stdio.h>
#include <string.h>
#include <time.h>

#include <windowsx.h>
#define STRICT
#include <windows.h>
#include <commdlg.h>

#define ZLIB_DLL

#include "zlib.h"

unsigned char pqahead[] = {
  'l', 'n', 'c', 'h',
  0, 3, 0x80, 1,
};

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int cmdShow)
{

  unsigned long cofst;
  unsigned char bbuf[65534];
  unsigned char obuf[4200];
  unsigned short xshort;
  unsigned long xlong, xid, fsize;
  long bbuflen;
  int maxsect, i;
  char fname[256], title[40], *inbuf, *outbuf, *cmdlp, dbname[36];
  FILE *outfd, *infd;
  z_stream pgpz;

  char *tAIB1 = NULL, *tAIB0 = NULL, *tAIN = NULL, *tver = NULL;
  int ntAIB1 = 0, ntAIB0 = 0, ntAIN = 0, ntver = 0;

  WIN32_FIND_DATA findat;
  OPENFILENAME winofn;

  cmdlp = lpCmdLine;
  if (!lpCmdLine || !strlen(lpCmdLine)) {

    memset(&winofn, 0, sizeof(OPENFILENAME));
    winofn.lStructSize = sizeof(OPENFILENAME);
    //  winofn.hwndOwner = 0;        // An invalid hWnd causes non-modality
    winofn.lpstrFilter = (LPSTR) "Palm Resource (*.prc)\0*.prc\0";
    winofn.nFilterIndex = 1;
    winofn.lpstrFile = (LPSTR) fname; // Stores the result in this variable
    winofn.nMaxFile = sizeof(fname);
    winofn.lpstrTitle = "File to compress"; // Title for dialog
    winofn.Flags = OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST;
    winofn.lpstrDefExt = "*";
  }

  for (;;) {
    fname[0] = 0;
    if (strlen(cmdlp)) {
      strcpy(fname, cmdlp);
      for (cofst = 0; cofst < strlen(fname); cofst++)
        if (fname[cofst] == ' ') {
          fname[cofst] = 0;
          break;
        }

      cmdlp += strlen(fname);
      while (*cmdlp && *cmdlp == ' ')
        cmdlp++;
      {
      }
    } else {

      if (lpCmdLine && strlen(lpCmdLine))
        break;

      if (GetOpenFileName(&winofn) != TRUE) {
        xlong = CommDlgExtendedError();
        if (xlong != 0)         // 0 value means user selected Cancel
        {
          sprintf(bbuf, "File Open returned error %ld", xlong);
          MessageBox(0, bbuf, "WARNING", MB_OK | MB_ICONSTOP);
          continue;
        } else
          break;
      }
    }
    if (!(infd = fopen(fname, "rb")))
      exit(-1);

    FindClose(FindFirstFile(fname, &findat));

    fread(dbname, 1, 32, infd);
    fseek(infd, 76, SEEK_SET);
    fread(&xshort, 1, 2, infd); /* num resources */

    maxsect = htons(xshort);

    for (i = 0; i < maxsect; i++) {
      fread(title, 1, 4, infd);
      fread(&xshort, 1, 2, infd);
      xshort = htons(xshort);
      sprintf(&title[4], "%04x", xshort);

      fread(&xlong, 1, 4, infd);
      cofst = htonl(xlong);
      xlong = ftell(infd);

      if (i + 1 != maxsect) {
        fread(&bbuflen, 1, 4, infd);
        fread(&bbuflen, 1, 2, infd);
        fread(&bbuflen, 1, 4, infd);
        bbuflen = htonl(bbuflen);
        bbuflen = bbuflen - cofst;
      } else
        bbuflen = 65534;

      fseek(infd, cofst, SEEK_SET);
      bbuflen = fread(bbuf, 1, bbuflen, infd);
      fseek(infd, xlong, SEEK_SET);

      if (!strcmp("tAIN03e8", title)) {
        ntAIN = (bbuflen + 1) / 2;
        tAIN = malloc(ntAIN * 2);
        memcpy(tAIN, bbuf, ntAIN * 2);

      }

      if (!strcmp("tAIB03e8", title)) {
        ntAIB0 = (bbuflen + 1) / 2;
        tAIB0 = malloc(ntAIB0 * 2);
        memcpy(tAIB0, bbuf, ntAIB0 * 2);
      }

      if (!strcmp("tAIB03e9", title)) {
        ntAIB1 = (bbuflen + 1) / 2;
        tAIB1 = malloc(ntAIB1 * 2);
        memcpy(tAIB1, bbuf, ntAIB1 * 2);
      }

      if (!strcmp("tver0001", title)) {
        ntver = (bbuflen + 1) / 2;
        tver = malloc(ntver * 2);
        memcpy(tver, bbuf, ntver * 2);
      }

    }

    fseek(infd, 0, SEEK_END);
    fsize = ftell(infd);
    fseek(infd, 0, SEEK_SET);

    inbuf = malloc(fsize);
    outbuf = malloc(fsize + 10);

    memset(&pgpz, 0, sizeof(pgpz));
    deflateInit2(&pgpz, 9, Z_DEFLATED, -15, 8, 0);

    pgpz.next_in = inbuf;
    pgpz.avail_in = fsize;
    fread(inbuf, 1, fsize, infd);
    pgpz.next_out = outbuf;
    pgpz.avail_out = fsize + 10;
    deflate(&pgpz, Z_FINISH);
    deflateEnd(&pgpz);

    i = fsize + 10 - pgpz.avail_out;
    //   fprintf(stderr, "Compressed: %ld%%\n", 100 - i * 100 / fsize );
    fsize = i;

    maxsect = fsize / 4096 + 1;
    cofst = 80 + 8 * maxsect;

    if (!strcmp(&fname[strlen(fname) - 4], ".prc"))
      fname[strlen(fname) - 4] = 0;
    if (!strcmp(&fname[strlen(fname) - 4], ".PRC"))
      fname[strlen(fname) - 4] = 0;
    if (!strcmp(&fname[strlen(fname) - 4], ".Prc"))
      fname[strlen(fname) - 4] = 0;

    strcat(fname, ".pdb");

    if (!(outfd = fopen(fname, "wb")))
      exit(-1);

    fwrite(dbname, 1, 32, outfd);

    memset(bbuf, 0, 4);
    bbuf[0] = 2;
    bbuf[1] = 0x88;
    bbuf[3] = 1;
    fwrite(bbuf, 1, 4, outfd);
    //36
    xlong = time(NULL) + ((66 * 365 + 17) * 24 * 3600UL);
    xlong = htonl(xlong);

    fwrite(&xlong, 1, 4, outfd);
    fwrite(&xlong, 1, 4, outfd);
    fwrite(&xlong, 1, 4, outfd);
    //48
    memset(bbuf, 0, 12);
    fwrite(bbuf, 1, 4, outfd);
    xlong = htonl(cofst);
    fwrite(&xlong, 1, 4, outfd);


    cofst += 8 + 8 + ntAIB0 * 2 + ntAIB1 * 2 + ntAIN * 2 + ntver * 2;

    fwrite(bbuf, 1, 4, outfd);

    //60
    fwrite("DATA", 1, 4, outfd);
    fwrite("TZIP", 1, 4, outfd);

    bbuf[0] = 0x28;
    fwrite(bbuf, 1, 8, outfd);

    xshort = htons((unsigned short) maxsect);
    fwrite(&xshort, 1, 2, outfd);

    xid = 0x40000000UL + (rand() & 0x7fffffUL);


    while (maxsect--) {
      xlong = htonl(cofst);
      fwrite(&xlong, 1, 4, outfd);
      xlong = htonl(xid++);
      fwrite(&xlong, 1, 4, outfd);
      cofst += 4104;
    }

    xshort = 0;
    fwrite(&xshort, 1, 2, outfd);

    fwrite(pqahead, 1, 8, outfd);

    xshort = htons((unsigned short) ntver);
    fwrite(&xshort, 1, 2, outfd);
    if (ntver) {
      fwrite(tver, 1, ntver * 2, outfd);
      free(tver);
    }

    xshort = htons((unsigned short) ntAIN);
    fwrite(&xshort, 1, 2, outfd);
    if (ntAIN) {
      fwrite(tAIN, 1, ntAIN * 2, outfd);
      free(tAIN);
    }

    xshort = htons((unsigned short) ntAIB0);
    fwrite(&xshort, 1, 2, outfd);
    if (ntAIB0) {
      fwrite(tAIB0, 1, ntAIB0 * 2, outfd);
      free(tAIB0);
    }

    xshort = htons((unsigned short) ntAIB1);
    fwrite(&xshort, 1, 2, outfd);
    if (ntAIB1) {
      fwrite(tAIB1, 1, ntAIB1 * 2, outfd);
      free(tAIB1);
    }

    tAIB1 = NULL, tAIB0 = NULL, tAIN = NULL, tver = NULL;
    ntAIB1 = 0, ntAIB0 = 0, ntAIN = 0, ntver = 0;

    strcpy(obuf, "DBLK");
    obuf[5] = obuf[7] = obuf[4] = 0;
    obuf[6] = 0x10;

    while (fsize > 4096) {
      fwrite(obuf, 1, 8, outfd);
      fwrite(outbuf, 1, 4096, outfd);
      outbuf += 4096;
      fsize -= 4096;
    }

    fwrite(obuf, 1, 4, outfd);
    xlong = htonl(fsize);
    fwrite(&xlong, 1, 4, outfd);
    fwrite(outbuf, 1, fsize, outfd);

    fclose(infd);
    fclose(outfd);
  }
  return 0;
}
