#include <PalmOS.h>
#include <PalmCompatibility.h>

typedef unsigned long size_t;
#include "stringil.h"
#include "stdio2.h"
#include "faxruns.h"
unsigned char cvtbuf[2048];

#include "zfaxz.h"
extern int dodlg(int id);

static int dubline;

#define bitsout(x) { \
  d = x; \
  while (*d) { \
    if (*d++ & 1) \
      t |= outbit; \
    outbit >>= 1; \
    if (!outbit) { \
      *c++ = t; \
      t = 0; \
      count++; \
      outbit = 0x80; \
    } \
  } \
}

// Note this is half-rez, doubling each pixel.

void convert(unsigned char *bb, FileHand fd)
{
  int i, j, r, bit;
  int outbit, count;
  unsigned char *c, *d, t;

  for (i = 0; i < 16; i++) {
    j = 0;
    while (j < 108 && !*bb)
      j++, bb++;

    if (j == 108) {
      fwrite(blankline, 1, 4, fd);
      if (dubline)
        fwrite(blankline, 1, 4, fd);
      continue;
    }

    r = j << 3;
    c = cvtbuf;
    bit = 0x80;
    outbit = 0x80;
    t = 0;
    count = 0;

    while (j < 108) {

      while (j < 108) {
        while (bit) {
          if (*bb & bit)
            break;
          r++;
          bit >>= 1;
        }
        if (bit)
          break;
        bit = 0x80;
        for (;;) {
          j++;
          if (*++bb || j > 107)
            break;
          r += 8;
        }
      }

      bitsout(ntwhite[r >> 5]);
      bitsout(twhite[r & 31]);
      r = 0;

      if (j > 107)
        break;

      while (j < 108) {
        while (bit) {
          if (!(*bb & bit))
            break;
          r++;
          bit >>= 1;
        }
        if (bit)
          break;
        bit = 0x80;

        for (;;) {
          j++;
          if (*++bb != 0xff || j > 107)
            break;
          r += 8;
        }

      }

      bitsout(ntblack[r >> 5]);
      bitsout(tblack[r & 31]);
      r = 0;

    }
    if (outbit != 0x80) {
      *c++ = t;
      count++;
    }

    *c++ = 0;
    *c++ = 0;
    *c++ = 1;
    count += 3;
    fwrite(cvtbuf, 1, count, fd);
    if (dubline)
      fwrite(cvtbuf, 1, count, fd);

  }
}

char name[32];
extern char retstr[256];
char *faxcvt(char *fname)
{
  FileHand fd, ifd;
  Err err;
  WinHandle w2;
  WinPtr w1;
  BitmapType *bp;
  unsigned char *bb;
  void *xp;
  char *c;
  int cmax, linecnt;
  UInt16 slen;
  RectangleType r = { {32, 0}, {160, 16} };
  UInt32 romVersion;
  UInt32 deep, odeep;

  // SET NAME from dialog
  strcpy(retstr, "FAX");
  StrIToH(&retstr[3], TimGetSeconds());
  if (!dodlg(ffname))
    return NULL;

  FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);

  if (!fname) {
    xp = ClipboardGetItem(clipboardText, &slen);
    if( !xp )
      return NULL;
    //+++ ERROR: Nothing to paste...
    c = MemHandleLock(xp);
    ifd = NULL;
  } else {
    ifd = FileOpen(0, fname, 'DATA', 'BOXR',
                   fileModeReadOnly | fileModeAnyTypeCreator, NULL);
    if (!ifd)
      return 0;
    c = MemPtrNew(4096);
    xp = c;
    memset(c, 0, 4096);
    fread(c, 1, 4096, ifd);
    if (feof(ifd)) {
      fclose(ifd);
      ifd = NULL;
    }
  }

  deep = 1;
  ScrDisplayMode(scrDisplayModeGet, NULL, NULL, &odeep, NULL);
  ScrDisplayMode(scrDisplayModeSet, NULL, NULL, &deep, NULL);

  w1 = WinCreateOffscreenWindow(864, 16, 0, &err);
  w2 = WinSetDrawWindow(w1);
  if (romVersion >= sysMakeROMVersion(3, 5, 0, sysROMStageRelease, 0)) {
    bp = WinGetBitmap(w1);
    bb = BmpGetBits(bp);
  } else {
    bp = w1->bitmapP;
    bb = (unsigned char *) &bp[1];
    if (bp->flags.indirect)
      bb = (unsigned char *) *(unsigned long *) bb;
    else {
      WinEraseWindow();
      memcpy(cvtbuf, bb, 2048);
      r.topLeft.x = 0;
      WinDrawRectangle(&r, 0);
      slen = 0;
      while (*bb == cvtbuf[slen++])
        bb++;
      r.topLeft.x = 32;
    }
  }

  FntSetFont(largeFont);
  dubline = 1;                  //hirez

  strcpy(name, retstr);
  strcat(name, ".000");

  //FOR EACH PAGE...
  cmax = 1;
  while (cmax) {

    if (name[strlen(name) - 1] != '9')
      name[strlen(name) - 1]++;
    else
      name[strlen(name) - 1] = 'A';

    fd = FileOpen(0, name, 'DATA', 'ZFAX', fileModeReadWrite, NULL);

    // Start with 3 blank lines

    fwrite(fxeol, 1, 3, fd);
    for (slen = 0; slen < (dubline + 1) * 16 * 3; slen++)
      fwrite(blankline, 1, 4, fd);

    linecnt = 0;
    while ((cmax = strlen(c))) {

      if (ifd && cmax < 1024) {
        // append another chunk for file convert
        strcpy(xp, c);
        c = xp;
        memset(&c[strlen(c)], 0, 4096 - strlen(c));
        fread(&c[strlen(c)], 1, 4096 - strlen(c), ifd);
        if (feof(ifd)) {
          fclose(ifd);
          ifd = NULL;
        }
      }

      if (linecnt == 60)
        break;
      linecnt++;

      WinSetDrawWindow(w2);
      StrIToA(bb, linecnt);
      strcat(bb, "/");
      strcat(bb, &name[strlen(name) - 1]);
      strcat(bb, "      ");
      WinDrawChars(bb, strlen(bb), 0, 0);
      WinSetDrawWindow(w1);

      if (cmax > 256)
        cmax = 256;

      //cmax = first linefeed
      for (slen = 0; slen < cmax; slen++) {
        if (c[slen] == '\r') {
	  if( slen+1 < cmax && c[slen+1] == '\n' )
	    c[slen]=' ';
	  else
	    c[slen] = '\n';
	}
        if (c[slen] == '\n')
          break;
      }
      cmax = slen;

      // if too wide
      if ((slen = FntCharsWidth(c, cmax)) > 800) {
        // Rewind to just before final overlap
        do {
          slen -= FntCharWidth(c[--cmax]);
        } while (slen > 800);
        // chop at earliest space (if there is a space)
        slen = cmax;
        while (cmax && cmax != strlen(c) && c[cmax - 1] != ' ')
          cmax--;
        if (!cmax)
          cmax = slen;
      }

      WinEraseWindow();
      WinDrawChars(c, cmax, 32, 0);
      convert(bb, fd);

      r.topLeft.x = 32;
      WinCopyRectangle(w1, w2, &r, 0, 32, winPaint);
      r.topLeft.x += 160;
      WinCopyRectangle(w1, w2, &r, 0, 48, winPaint);
      r.topLeft.x += 160;
      WinCopyRectangle(w1, w2, &r, 0, 64, winPaint);
      r.topLeft.x += 160;
      WinCopyRectangle(w1, w2, &r, 0, 80, winPaint);
      r.topLeft.x += 160;
      WinCopyRectangle(w1, w2, &r, 0, 96, winPaint);

      c += cmax;
      if (*c == '\n')
        c++;
      else
        while (*c && *c == ' ')
          c++;
    }

    // Append 3 blank lines
    for (slen = 0; slen < (dubline + 1) * 16 * 3; slen++)
      fwrite(blankline, 1, 4, fd);

    fclose(fd);
  }

  WinSetDrawWindow(w2);
  ScrDisplayMode(scrDisplayModeSet, NULL, NULL, &odeep, NULL);

  if (!fname)
    MemHandleUnlock(xp);
  else
    MemPtrFree(xp);

  FntSetFont(stdFont);
  name[strlen(name) - 1] = '1';
  return name;
}
